> For the complete documentation index, see [llms.txt](https://docs.contextual.io/documentation-and-resources/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.contextual.io/documentation-and-resources/components-and-data/object-types/object-type-details/data-schema/automatic-metadata.md).

# Automatic Record Metadata

As you design your Object Type Data Schema, keep in mind that there are several things that are automatically generated, stored, and kept up to date as metadata for a record, so you can conveniently use these values throughout your solution and don't need to include them in the Data Schema itself.

* `createdAt`: ISO 8601 date and time
* `updatedAt`: ISO 8601 date and time
* `hash`: using all Record details that are not in `_metaData`, this unique 64-character alphanumeric value is updated with every modification of a Record and can be used in your solution for version control, change validation, and concurrency control (only the version of the record you expect to be updated, is updated), and other purposes
* `schema`: identifier for the Object Type Data Schema
* `type`: for Object Types that you create in Contextual, always "custom"
* `secrets`: an array of paths to stored secret properties, including nested properties and array entries; see [Secrets](/documentation-and-resources/components-and-data/object-types/object-type-details/data-schema/secret.md) for response and decryption behavior

{% code title="Record Metadata Example" lineNumbers="true" %}

```json
"_metaData": {
  "createdAt": "2024-05-09T14:22:50.588Z",
  "hash": "894ab5c5bc0f03daca18bfc835d8fbf4ca315842f24d7d696b5b436222aa5eed",
  "id": "87111",
  "schema": "native-object:zipcodes",
  "type": "custom",
  "updatedAt": "2024-05-09T14:22:50.588Z",
  "secrets": []
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.contextual.io/documentation-and-resources/components-and-data/object-types/object-type-details/data-schema/automatic-metadata.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
